/*
bhups.h - a usp status collection client. 
Copyright (C) 2002  Al Kingsley


  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   Don't write to me at: kingsley@bananahead.com 

   Part of:
   BhPos Copyright (C) 2002 Al Kingsley
   BhPos comes with ABSOLUTELY NO WARRANTY.
    
The shape of things to come:


*/
#ifndef _UPS_H_
#define _UPS_H_

#include "bhdev.h"

namespace BhPos{

enum BhUpsType{
   UPS_TYPE_SERIAL,
   UPS_TYPE_LINE,
   UPS_TYPE_NETWORK
};

enum BhUpsSignalLine{
   UPS_SIGNALLINE_ONBATTERY,
   UPS_SIGNALLINE_LOWBATTERY,
   UPS_SIGNALLINE_SHUTDOWN,
   UPS_SIGNALLINE_CABLEPOWER
};
  
enum BhUpsStatus{
   BHUPS_STATUS_OK,
   BHUPS_STATUS_LINEFAIL,
   BHUPS_STATUS_BATLOW,
   BHUPS_STATUS_ERROR
};

typedef struct taglinemap{
   int             signal;
   BhUpsSignalLine target;
   char            inverted;
   char            status;
}linemap;

class CBhUps : public CBhDevice
{
private:
   BhUpsType type;
   linemap map[4];
   char *query_string;
   char *ok_string;
   char *error_string;
   char *batlow_string;
   int  timer_death;
   int  curr_count;
   bool bTimer;
   BhUpsStatus status;

public:
   CBhUps(BhDevType, int, BHDEV_CALLBACK);
   ~CBhUps();
   gint Timeout();
   int Collect();
   int SetDeathTimer(int);   //! The time from powerfail to snapshot
   int SetUpdateTime(int);   //! The update period
};

namespace Parser{

class CBhUpsParser
{
	xmlNsPtr	ns;
	
public:
	CBhUpsParser();
	~CBhUpsParser();
	//int Open(char *file_name, xmlNsPtr name_space, CBhDevice& target_device);
};
   
}

}

#endif //   _UPS_H_
