#ifndef _BHCLIST_H_
#define _BHCLIST_H_

#include <gtk--/main.h> 
#include <gtk--/clist.h>
#ifndef _BHHDR_H_
#include "pos.h"
#endif
#ifndef _CTRANSITEM_
#include "../bhtrans/ctransitems.h"
#endif
#ifndef _CCASH_H_
#include "cash.h"
#endif

namespace BhPos{

/**
 * @defgroup bhwidget Widgets
 * @{
 *
 * @ingroup commlib
 * @{	
 */
   
namespace Widget{

/*
 * @defgroup bhclist List
 * @{
 *
 * @ingroup bhwidget
 * @{	
 */

#define BHCLIST_MODE_IDLE             1
#define BHCLIST_MODE_ITEMADD          2
#define BHCLIST_MODE_ITEMWAIT         3
#define BHCLIST_MODE_READY            4
#define BHCLIST_MODE_PAY              5
#define BHCLIST_MODE_WAITACK          6
#define BHCLIST_MODE_EDITSALE         7
#define BHCLIST_MODE_EDITPAY          9
#define BHCLIST_MODE_PRICEADD         10
#define BHCLIST_MODE_PAYWAIT          11
#define BHCLIST_MODE_PAYENTRY         12
#define BHCLIST_MODE_DESCPRICE        13
#define BHCLIST_MODE_TRANSSUM         14 
#define BHCLIST_MODE_USERSUM          15
#define BHCLIST_MODE_CASHDADJUST      16
#define BHCLIST_MODE_RETURNS          17
#define BHCLIST_MODE_LAYBYNEW         18
#define BHCLIST_MODE_LAYBYADDITEM     19
#define BHCLIST_MODE_LAYBYSUMMARY     20
#define BHCLIST_MODE_LAYBYADDPAY      21
#define BHCLIST_MODE_EPHEMSUMMARY     22
#define BHCLIST_MODE_EPHEMSTOCKRET    23
#define BHCLIST_MODE_BLINDBALANCE     24
#define BHCLIST_MODE_DELVIVERYLIST    25
#define BHCLIST_MODE_DELVIVERYRETLIST 26
#define BHCLIST_MODE_UNDELVIVEREDSCAN 27
#define BHCLIST_MODE_DELVIVERYREC     28
#define BHCLIST_MODE_RENTALRETURN	  29
#define BHCLIST_MODE_CUSTOMERLIST	  30
#define BHCLIST_MODE_DELIVERYSUMMARY  31
#define BHCLIST_MODE_OPENINGBALANCE   32
#define BHCLIST_MODE_RETURNREASON     33
#define BHCLIST_MODE_TRANSLIST        34
#define BHCLIST_MODE_PRICELIST        35
#define BHCLIST_MODE_TAXADD           36

#define BHCLIST_ITEMFLAGS_NOADD           1
#define BHCLIST_ITEMFLAGS_NOLISTADD       2
#define BHCLIST_ITEMFLAGS_STALEADD        3
#define BHCLIST_ITEMFLAGS_DROPNEXT        4
#define BHCLIST_ITEMFLAGS_SALE            5
#define BHCLIST_ITEMFLAGS_QUANTITY        6
#define BHCLIST_ITEMFLAGS_ALLAMOUNT       7
#define BHCLIST_ITEMFLAGS_CLEAR           8
#define BHCLIST_ITEMFLAGS_CLEARCURR       9
#define BHCLIST_ITEMFLAGS_CLEARQUANTITY   10
#define BHCLIST_ITEMFLAGS_TENDERAMOUNT    11
#define BHCLIST_ITEMFLAGS_ACK             12
#define BHCLIST_ITEMFLAGS_CASHADD         13
#define BHCLIST_ITEMFLAGS_CAOPSET         14
#define BHCLIST_ITEMFLAGS_CAOPADD         15
#define BHCLIST_ITEMFLAGS_CAOPSUB         16
#define BHCLIST_ITEMFLAGS_CADROPOP        17
#define BHCLIST_ITEMFLAGS_CAAMOUNT        18
#define BHCLIST_ITEMFLAGS_RETURN          19
#define BHCLIST_ITEMFLAGS_LAYBY           20
#define BHCLIST_ITEMFLAGS_EPHEMERAL       21
#define BHCLIST_ITEMFLAGS_RENTAL          22
#define BHCLIST_ITEMFLAGS_PRICE           23
#define BHCLIST_ITEMFLAGS_DESCPRICE       24
#define BHCLIST_ITEMFLAGS_BLINDBALANCE    25
#define BHCLIST_ITEMFLAGS_QUANTITYEDIT    26
#define BHCLIST_ITEMFLAGS_FULLADD	      27
#define BHCLIST_ITEMFLAGS_QUANTITYINC     28
#define BHCLIST_ITEMFLAGS_QUANTITYDEC     29
#define BHCLIST_ITEMFLAGS_TAX             32
#define BHCLIST_ITEMFLAGS_DISCOUNT        33
#define BHCLIST_ITEMFLAGS_QUANTITYSET     34
#define BHCLIST_ITEMFLAGS_QUANTITYREMOVE  35
#define BHCLIST_ITEMFLAGS_PRICECLOSE      36

#define BHCLIST_BBFLAGS_CASH              1
#define BHCLIST_BBFLAGS_CASHDISCREP       2
#define BHCLIST_BBFLAGS_CHEQUE            3
#define BHCLIST_BBFLAGS_CHEQUEDISCREP     4
#define BHCLIST_BBFLAGS_COUPONS           5
#define BHCLIST_BBFLAGS_COUPONSDISCREP    6
#define BHCLIST_BBFLAGS_VOUCHERS          7
#define BHCLIST_BBFLAGS_VOUCHERSDISCREP   8

#define BHCLIST_ROWTYPE_BLANK          0
#define BHCLIST_ROWTYPE_SPACER         1
#define BHCLIST_ROWTYPE_EXTRADATA      2
#define BHCLIST_ROWTYPE_SALEITEM       3
#define BHCLIST_ROWTYPE_PLULOOKUP      4
#define BHCLIST_ROWTYPE_UPLUPRICE      5
#define BHCLIST_ROWTYPE_UPLUPRICEDESC  6
#define BHCLIST_ROWTYPE_PAYTITLE       7
#define BHCLIST_ROWTYPE_PAYITEM        8
#define BHCLIST_ROWTYPE_TRANSSUMTEXT   9
#define BHCLIST_ROWTYPE_TRANSSUMEDIT   10
#define BHCLIST_ROWTYPE_USERSUMTEXT    11
#define BHCLIST_ROWTYPE_USERSUMEDIT    12
#define BHCLIST_ROWTYPE_CASHDTEXT      13
#define BHCLIST_ROWTYPE_CASHDEDIT      14

#define BHCLIST_ROWFLAG_NONE           0
#define BHCLIST_ROWFLAG_COLLAPSED      1
#define BHCLIST_ROWFLAG_EXPANDED       2
#define BHCLIST_ROWFLAG_EPHEMERAL      3

#define BHCLIST_ROWSTYLE_NORMAL        1
#define BHCLIST_ROWSTYLE_COLOURED      2
#define BHCLIST_ROWSTYLE_HIGHLIGHTED   3
#define BHCLIST_ROWSTYLE_FLASHING      4

/*
 *}@
 * @ingroup bhwidget
 * @{	
 */

enum CashDrawerAjustType{
   CASHD_ADJUST_ABSOLUTE,
   CASHD_ADJUST_INCREMENTAL,
   CASHD_ADJUST_DECREMENTAL
};

/*
 *}@
 * @ingroup bhwidget
 * @{	
 */

enum CashAjustType{
   CASH_ADJUST_QUANTITY,
   CASH_ADJUST_AMOUNT
};

/*
 *}@
 * @ingroup bhwidget
 * @{	
 */

enum BhPayMode{
   PAYMODE_OFF,
   PAYMODE_ON,
   PAYMODE_RESET
};

/*
 *}@
 * @ingroup bhwidget
 * @{	
 */

enum BhCListMoveDirection{
   BHCLIST_MOVEDIRECTION_UP,
   BHCLIST_MOVEDIRECTION_CENTRE,
   BHCLIST_MOVEDIRECTION_DOWN
};

/*
 *}@
 * @ingroup bhwidget
 * @{	
 */

/*!
	\brief General list status.
*/

enum BhCListTransStatus{
   BHCLIST_TRANSSTATE_OK=0,         //! OK
	BHCLIST_TRANSSTATE_IDLE,
	BHCLIST_TRANSSTATE_AITEM,
	BHCLIST_TRANSSTATE_APAY,
	BHCLIST_TRANSSTATE_ARETURNS,
	BHCLIST_TRANSSTATE_ACUSTSUMM,
	BHCLIST_TRANSSTATE_ACUSTTRANS,
	BHCLIST_TRANSSTATE_ATRANSUMM,
	BHCLIST_TRANSSTATE_AUSERSUMM,
	BHCLIST_TRANSSTATE_ACASHD,
	BHCLIST_TRANSSTATE_BITEM,
	BHCLIST_TRANSSTATE_BPAY,
	BHCLIST_TRANSSTATE_BRETURNS,
	BHCLIST_TRANSSTATE_BCUSTSUMM,
	BHCLIST_TRANSSTATE_BCUSTTRANS,
	BHCLIST_TRANSSTATE_BTRANSUMM,
	BHCLIST_TRANSSTATE_BUSERSUMM,
	BHCLIST_TRANSSTATE_BCASHD
};

/*
 *}@
 * @ingroup bhwidget
 * @{	
 */

enum BhCListColour{
	BHCLIST_COLOUR_DEFAULT_FOREGROUND,
	BHCLIST_COLOUR_DEFAULT_BACKGROUND,
   BHCLIST_COLOUR_FOREGROUND_SELECTED, 
	BHCLIST_COLOUR_BACKGROUND_SELECTED,
   BHCLIST_COLOUR_CELL_FOREGROUND,
   BHCLIST_COLOUR_PAYMENT_BACKGROUND, 
	BHCLIST_COLOUR_PAYMENTHDR_FOREGROUND, 
	BHCLIST_COLOUR_PAYMENTLIST_FOREGROUND,
   BHCLIST_COLOUR_UPLU_FOREGROUND, 
	BHCLIST_COLOUR_PLULOOKUP_FOREGROUND,
   BHCLIST_COLOUR_RETURN_FOREGROUND,
	BHCLIST_COLOUR_LAYBY_FOREGROUND,
	BHCLIST_COLOUR_RENTAL_FOREGROUND,
	BHCLIST_COLOUR_EPHEMERAL_FOREGROUND
};

/*
 *}@
 * @ingroup bhwidget
 * @{	
 */

class BhCList : public Gtk::CList
{
private:
   int   mode_A;
   int   prevmode_A;
   bool  bLookupMode_A;
   bool  bDropItem_A;
   bool  bFlaggedItem_A;
   bool  bFlaggedMsg_A;
   int   curr_row_A;
   int   curr_col_A;
   int   pay_startrow_A, curr_payrow_A;
   int   curr_payment_type_A;
   int   num_visiblerows_A;
   
	int   mode_B;
   int   prevmode_B;
   bool  bLookupMode_B;
   bool  bDropItem_B;
   bool  bFlaggedItem_B;
   bool  bFlaggedMsg_B;
   int   curr_row_B;
   int   curr_col_B;
   int   pay_startrow_B, curr_payrow_B;
   int   curr_payment_type_B;
   int   num_visiblerows_B;

   GdkColor listrow_f;
	GdkColor listrow_b;
   GdkColor listrow_fsel; 
	GdkColor listrow_bsel;
   GdkColor listcell_bsel;
   GdkColor listrow_payment;
	GdkColor listrow_paytext;
	GdkColor listrow_paylist;
   GdkColor col_uplu;
	GdkColor col_plulu;
   GdkColor col_returnplu;
   GdkColor col_rentalplu;
	GdkColor col_laybyplu;
	GdkColor col_rxplu;
   
   int    num_cash;
   double cash;
   int    num_cheque;
   double cheque;
   int    num_token;
   double token;
   int    num_credit;
   double credit;
   int    num_other;
   double other;
   
   Gtk::Connection timer;
   Gtk::Connection c_timer;
   bool bCursorEdit;
   int  cursor_cell;
   int  cursor_pos;
   
   int  ItemFlasher(int boo);
   void FlashItem(bool);
   int  CellFlasher(int boo);
   int  CursorFlasher(int boo);
   int  ItemFromRow(int, BhPos::CSaleItem&);
   int  ItemFromRow(int, BhPos::CPayItem&);
   // for later adjustable enhancements
   int  AdjustColWidth(char *);
   int  AdjustColWidth(BhPos::CSaleItem&);
   
protected:
   bool               bTaxInclusive;
   bool               bTransaction_A;
   BhPos::CTransItems items_A, items_B;
   BhPos::CSaleItem   curr_item;
   BhPos::CPayItem    curr_payitem;
   BhPos::CCash		 curr_cash;
   double             bb_start, bb_close, bb_running;
   int                bb_num, bb_cheques, bb_coupons, bb_vouchers;
   int                bbs_cheques, bbs_coupons, bbs_vouchers;

	void draw_focus(){}
   void draw_focus_impl();
   void toggle_focus_row_impl();
   void toggle_add_mode_impl();
   
   int  GetNumItems();
   void InsertBlankRow();
   //int  GetCurrentRow(int flags);
   int  CurrentItem();
   int  CheckVisible(int, BhCListMoveDirection);
   int  VisibleRowCount(int);
   
public:
   BhCList(int);
   ~BhCList();
   int  Clear();
	//! \brief Fairly obvious.
	/*! Set the displayed items to include tax. This simply displays items with, or without the tax in the displayed item.
		For example, in most of europe tax is inclusive, the tax is included in the displayed price, and the total displayed
		includes the tax. In the US, tax is exclusive and the displayed amount needs to be added to the tax value to give the total.
	*/
	//	\param bInclusive true to set tax inclusive, false otherwise.
   void SetTaxinclusive(bool bInclusive);
	//! \brief Reset list waiting on lookup return.

   void CancelLookup();
   void SelectRow(unsigned int, bool);
   void SetCash(BhPos::CCash&);
   void GetCash(BhPos::CCash&);
	/*!
		\brief Remove an item by index.
		
		Remove an item by absolute index into the list (referenced from 0).
		\param index
		\return 0 on success.
	*/
   int  Remove(int index);
	/*!
		\brief Remove an item by item.
		
		Remove an item by a list search for item.
		\param item (PLU only needs to be set).
		\return 0 on success.
	*/
   int  Remove(CSaleItem& item);
   int  CashDrawer(CashDrawerAjustType op, int type, double amount);
	/*!
		\brief Return the transaction that has focus.
	*/
   int  TransFocus();
	/*!
		\brief Return the number of individual items in the currently focused list.
	*/
   int  NumItems();
   /*!
		\brief Return the number of all items in the currently focused list.
	*/
   int  NumAllItems();
	/*!
		\brief Return the number of items in the transaction by index.
	*/
   int  NumItems(int transaction_index);
	/*!
		\brief Return the number of payment items in the currently focused list.
	*/
   int  NumPayItems();
	/*!
		\brief Set the currently focused transaction ID.
	*/
   void SetTransID(int);
   
   int  GetNameID();
   void SetNameID(int);
   int  GetMode();
	/*!
		\brief Get the currently focused transaction.
	*/
   BhPos::CTransItems *Get();
   int  Set(BhPos::CTransItems *);
	/*!
		\brief Set the text of an item.
		
		Generally it will set the text of a pre-lookup item (PLU, or quantity), or the text of a post lookup item (price or 
		description, or both) in an unknown PLU lookup, or be used for text changes in list editing mode.
		This function is used more in focused changes, contrast with Edit().
		\param text the text to set.
		\param flags various flags.
		- This runs to:
			- BHCLIST_ITEMFLAGS_NOADD           
			- BHCLIST_ITEMFLAGS_NOLISTADD       
			- BHCLIST_ITEMFLAGS_STALEADD        
			- BHCLIST_ITEMFLAGS_DROPNEXT        
			- BHCLIST_ITEMFLAGS_SALE            
			- BHCLIST_ITEMFLAGS_QUANTITY        
			- BHCLIST_ITEMFLAGS_ALLAMOUNT       
			- BHCLIST_ITEMFLAGS_CLEAR           
			- BHCLIST_ITEMFLAGS_CLEARCURR       
			- BHCLIST_ITEMFLAGS_CLEARQUANTITY   
			- BHCLIST_ITEMFLAGS_TENDERAMOUNT    
			- BHCLIST_ITEMFLAGS_ACK             
			- BHCLIST_ITEMFLAGS_CASHADD         
			- BHCLIST_ITEMFLAGS_CAOPSET         
			- BHCLIST_ITEMFLAGS_CAOPADD         
			- BHCLIST_ITEMFLAGS_CAOPSUB         
			- BHCLIST_ITEMFLAGS_CADROPOP        
			- BHCLIST_ITEMFLAGS_CAAMOUNT        
			- BHCLIST_ITEMFLAGS_RETURN          
			- BHCLIST_ITEMFLAGS_LAYBY           
			- BHCLIST_ITEMFLAGS_EPHEMERAL       
			- BHCLIST_ITEMFLAGS_RENTAL          
			- BHCLIST_ITEMFLAGS_PRICE           
			- BHCLIST_ITEMFLAGS_DESCPRICE       
			- BHCLIST_ITEMFLAGS_BLINDBALANCE    
			- BHCLIST_ITEMFLAGS_QUANTITYEDIT    
			- BHCLIST_ITEMFLAGS_FULLADD	
		\return 0 on success.
		\sa Edit
	*/
   int  ItemText(char *text, unsigned int flags);
	/*!
		Set list pay mode.
		\param BhPayMode set pay mode.
      
      \sa BhPayMode
	*/
   void SetPayMode(BhPayMode);
   void SetReturnsMode(bool);
   int  Add(BhPos::CSaleItem&, unsigned int flags);
   int  AddPayment(BhPos::CPayItem& pi, unsigned int flags);
   void DisplayChange();
	/*!
		\brief Edit some value of an item.
		
		Generally used in unfocused changes, contrast with ItemText().
		\param what the item to set.
		- This runs to:
			- BHCLIST_ITEMQUANTITY_INC
			- BHCLIST_ITEMQUANTITY_DEC
			- BHCLIST_ITEM_DESCPRICE
			- BHCLIST_ITEM_PRICE
			- BHCLIST_ITEM_TAX
			- BHCLIST_ITEM_DISCOUNT
			- BHCLIST_ITEM_QUANTITYSET
		\param data void pointer dynamically cast to according to the what flag.
		\return 0 on success.
		\sa  ItemText
	*/
   int  Edit(int what, void *data);
   void StartNavigation();
   int  Navigation(unsigned int);
   int  EndNavigation();
   
   BhCListTransStatus Update();

   BhCListTransStatus CashAdjust(BhPos::CCash&, bool);
   BhCListTransStatus TransSummary(bool, BhServiceTransSum *ts);
   BhCListTransStatus UserSummary(bool, BhServiceUserSum *us);
   
   BhCListTransStatus EphemeralsIn(bool bShow);
   BhCListTransStatus Ephemerals(BhPos::CTransItems&, BhPos::CTransItems&, bool bShow);
   /*!
		\brief Display a list of customers.
		
		In a customer lookup conflict, display a list of customers to select from.
		\param cl list of customers returned from server
      \param bShow Show or hide customer list.
		\return BhCListTransStatus.
		\sa BhCListTransStatus
	*/
   BhCListTransStatus CustomerList(BhCustomerList *cl, bool bShow);
   int  CustomerSelection(char *);
   
   BhCListTransStatus DeliveryList(BhDeliveryList *, bool bShow);
   BhCListTransStatus DeliverySummary(BhDeliveryList *dl, bool bShow);
   BhCListTransStatus DeliveryReturnList(BhDeliveryReturnList *, bool bShow);
   
   BhCListTransStatus RentalList(BhRentalList *, bool bShow);
   
   int  Layby(BhPos::CTransItems&, bool bShow);
   BhCListTransStatus LaybySummary(BhLaybyList *, bool bShow);
   
   BhCListTransStatus ReturnReason(BhReturnReasonList *rl, bool bShow);
   BhCListTransStatus PriceList(BhPriceList *pl, bool bShow);
   
   BhCListTransStatus BhCList::OpenTransList(BhTransRoverList *rl, bool bShow);
   BhCListTransStatus BhCList::OpeningBalance(BhPos::CCash& cashd, bool bShow);
   
   BhCListTransStatus BlindBalance(BhBlindBalanceReply *, bool bShow);
   int  BlindBalanceCash(int, double *);
   int  BlindAmount(int);
   void BlindBalanceReset(int);
   
   void OpeningBalanceEdit(CashAjustType type, int num, double amount);
   
   int  DeliverySelection(bool);
   int  DeliveryReturnSelection(bool);
   int  ReturnSelection();
   int  PriceListSelection(char *);
   
   int   Swap();
   double GetNumber(BhTransNumber);
   BhPos::CSaleItem& GetItem();
   BhPos::CPayItem&  GetPayItem();
   BhPos::CSaleItem& GetCurrItem();
   int  GetLaybyItem();
   int  CustomerTransSelect();
   void ClearCurrItem();
   int  ItemExists(CSaleItem& si);
	int  ItemExists(CPayItem& pi);
	int  UpdateItem(CSaleItem& si);
	int  UpdateItem(CPayItem& pi);
   int  AdjustCashDrawer(double, CashDrawerAjustType);
   int  AddPayType(BhPayType t);
   
   void SetRound(BhTransRoundType, float);
   
   void FlashCell(bool bOn, int cell);
   void PseudoCursor(bool bOn, int cell);

	void GetColour(BhCListColour, GdkColor *);
	void SetColour(BhCListColour, GdkColor *);
};

/* }@ 
	}@ */

}

/* }@ 
	}@ */

}
#endif // _BHCLIST_H_
