/*
bhclock.h
Copyright (C) 2003  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY. 
*/
#ifndef _CRAPCLOCK_H_
#define _CRAPCLOCK_H_

#include <gtk--/main.h>
#include <gtk--/window.h>
#include <gtk--/drawingarea.h>
#include <gtk--/pixmap.h>
#include <gdk--/color.h>
#include <gdk--/gc.h>

namespace BhPos{

/**
 * @ingroup bhwidget Widgets
 * @{
 *
 * @ingroup commlib
 * @{	
 */

namespace Widget{
/*
 * @defgroup clock
 * @{
 *
 * @ingroup bhwidget
 * @{	
 */

class BhClock : public Gtk::DrawingArea
{
private:
   bool   bColon;
	int	 xsMonth[12], xeMonth[12], ydMonth;
	int	 xsDayOfMonth[31];
	int	 xeDayOfMonth[31];
	int	 xeDayOfMonth2[31];
	int	 xdDayOfMonth[31];
	int	 xdDayOfMonth2[31];
	int	 ydDayOfMonth;
	int	 xsDayOfWeek[7], xeDayOfWeek[7], ydDayOfWeek;
	int	 xsDigits[12], xeDigits[12], xdDigits[11], ydDigits;
	int	 xsAMPM[2], yAMPM, xdAMPM[2], ydAMPM;
	tm		 *Time;
	int	 i, n, wid, extrady, extradx;
   int 	 Year, Month, DayOfWeek, DayOfMonth, OldDayOfMonth;
   int	 Hours, Mins, Secs, OldMins, digit, xoff, D[10], xsize;
   long	 CurrentLocalTime;
#if defined(FREEBSD) || defined(NETBSD) || defined(OPENBSD)
   long   CurrentTime;
#else
   time_t CurrentTime;
#endif
   int	 Flag, dFlag;
   bool   Show24HourTime;
   
protected:
   Gdk_GC     gc;
   Gdk_Window window;
   Gdk_Pixmap final;
   Gdk_Pixmap facia;
   Gdk_Pixmap date;
   Gdk_Pixmap day;
   Gdk_Pixmap month;
   Gdk_Pixmap timen;
   Gdk_Color  transparent_color;	

	void DrawTime();
   void DrawDayMonth();
	void Draw();
	
	Gtk::Connection con;
	gint	con_tag;
   virtual void realize_impl();
	virtual gint expose_event_impl(GdkEventExpose* e);

public:
	BhClock();
	~BhClock();
	gint Load(char *facianame, char *datename, char *dayname, char *monthname, char *timename);
	gint Update();
	double JulianDay(int ny, int nm, int nd, double UT);
	double Hour24(double hour);
};

/* }@ 
	}@ */

}
/* }@ 
	}@ */
}

#endif // _crapclock_h_
