/*
   numpad.h
   Copyright (C)2004 Al Kingsley

  GNU General Public License v2 or better
*/
#ifndef _BHNUMPAD_H
#define _BHNUMPAD_H

#include <gtk--/main.h>
#include <gtk--/table.h>
#include <gtk--/button.h>
#include <gtk--/pixmap.h>
#include <gdk--/color.h>
#include <gdk/gdkkeysyms.h>

namespace BhPos{

/**
 * @ingroup bhwidget
 * @{
 *
 * @ingroup commlib
 * @{	
 */

namespace Widget{
/*
 * @defgroup numpad
 * @{
 *
 * @ingroup bhwidget
 * @{	
 */
   
typedef int (*NPCALLBACK)(GdkEventKey *);

class BhNumPad : public Gtk::Table
{
private:
   Gtk::Pixmap   *b0;
   Gtk::Pixmap   *b1;
   Gtk::Pixmap   *b2;
   Gtk::Pixmap   *b3;
   Gtk::Pixmap   *b4;
   Gtk::Pixmap   *b5;
   Gtk::Pixmap   *b6;
   Gtk::Pixmap   *b7;
   Gtk::Pixmap   *b8;
   Gtk::Pixmap   *b9;
   Gtk::Pixmap   *bdecimal;
   Gtk::Pixmap   *bplus;
   Gtk::Pixmap   *bminus;
   Gtk::Pixmap   *bequal;
   Gtk::Pixmap   *bpgup;
   Gtk::Pixmap   *bup;
   Gtk::Pixmap   *bdown;
   Gtk::Pixmap   *bpgdown;
   Gtk::Pixmap   *breturn;
   Gtk::Pixmap   *bdelete;

   Gtk::Button *b_0;
   Gtk::Button *b_1;
   Gtk::Button *b_2;
   Gtk::Button *b_3;
   Gtk::Button *b_4;
   Gtk::Button *b_5;
   Gtk::Button *b_6;
   Gtk::Button *b_7;
   Gtk::Button *b_8;
   Gtk::Button *b_9;
   Gtk::Button *b_decimal;
   Gtk::Button *b_plus;
   Gtk::Button *b_minus;
   Gtk::Button *b_equal;
   Gtk::Button *b_pgup;
   Gtk::Button *b_up;
   Gtk::Button *b_down;
   Gtk::Button *b_pgdown;
   Gtk::Button *b_return;
   Gtk::Button *b_delete;

protected:
   void on_b0_clicked();
   void on_b1_clicked();
   void on_b2_clicked();
   void on_b3_clicked();
   void on_b4_clicked();
   void on_b5_clicked();
   void on_b6_clicked();
   void on_b7_clicked();
   void on_b8_clicked();
   void on_b9_clicked();
   void on_bdecimal_clicked();
   void on_bplus_clicked();
   void on_bminus_clicked();
   void on_bequal_clicked();
   void on_bpgup_clicked();
   void on_bup_clicked();
   void on_bdn_clicked();
   void on_bpgdn_clicked();
   void on_breturn_clicked();
   void on_bdelete_clicked();
   
   NPCALLBACK  kf_callback;

public:
   BhNumPad(NPCALLBACK);
   ~BhNumPad();
};
   
/* }@ 
	}@ */

}
/* }@ 
	}@ */
}

#endif
