/*
bhsmartbar.h 
Copyright (C) 2004  Al Kingsley

   GPL version 2 or later.

	Part of:
	BhPos, Copyright (C) 2001-2004   Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
#ifndef SMARTBAR_H
#define SMARTBAR_H

#include <gtk--/button.h>
#include <gtk--/toolbar.h>
#include <gtk--/pixmap.h>
#include <gdk/gdkkeysyms.h>

namespace BhPos{

/**
 * @infgroup bhwidget
 * @{
 *
 * @ingroup commlib
 * @{	
 */
   
namespace Widget{

/*
 * @defgroup smartbar A not very smart bar
 * @{
 *
 * @ingroup bhwidget
 * @{	
 */

enum BhSmartButton{
   BHSB_EXIT,
   BHSB_LOGOUT,
   BHSB_CANCEL,
   BHSB_CLEAR,
   BHSB_QUANTITY,
   BHSB_REQUEST,
   BHSB_SALEPRICE,
   BHSB_ABSWAP,
   BHSB_TOTAL,
   BHSB_CASH,
   BHSB_CHEQUE,
   BHSB_CREDIT,
   BHSB_CHARGE,
   BHSB_COMMIT,
   BHSB_ALLAMOUNT,
   BHSB_RETURN,
   BHSB_PLULOOKUP,
   BHSB_REMOVE,
   BHSB_PAYIN,
   BHSB_PAYOUT,
   BHSB_DISCOUNT,
   BHSB_RENTAL,
   BHSB_DELIVERY,
   BHSB_EPHEMERAL,
   BHSB_LAYBY,
   BHSB_NOSALE,
   BHSB_CASHITEM,
   BHSB_NEWCUST,
   BHSB_FINDCUST,
   BHSB_INCREMENT,
   BHSB_DECREMENT,
   BHSB_DELETE,
   BHSB_RETURNTRANS,
   BHSB_RETURNITEM
};
   
typedef struct tagskaction{
   unsigned int k;
   int  kl;
   int  m;
}skaction;

typedef struct tagbuttonitem{
   char label[16];
   Gtk::Pixmap *pm;
}buttonitem;

typedef int (*SBCALLBACK)(GdkEventKey *);

class BhSmartBar : public Gtk::Toolbar
{  
private:
   SBCALLBACK  kf_callback;

   void on_button_clicked(BhSmartButton);

protected:
   Gtk::Pixmap *AddTextImage(char *imagefile);
        
public:
   BhSmartBar(GtkOrientation orientation, GtkToolbarStyle style, SBCALLBACK);
   ~BhSmartBar();
   void Push(char *, char *, unsigned int *k, BhSmartButton, int m);
   void Insert(int, char *, char *, unsigned int *k, BhSmartButton, int m);
   void Remove(int);
};

/* }@ 
	}@ */

}

/* }@ 
	}@ */

}

#endif
