/*
   entry.h
   Copyright (C)2003  Al Kingsley


  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2002 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.

*/
#ifndef _BHENTRY_H
#define _BHENTRY_H

#include <gdk/gdk.h>
#include <gtk--/main.h>
#include <gtk--/entry.h>

namespace BhPos{
   
namespace Widget{

class BhEntry : public Gtk::Entry
{
public:
   enum BhEntryFlashType{
      BHENTRY_FLASH_TYPE_ONOFF=1,
      BHENTRY_FLASH_TYPE_COLOUR=2,
      BHENTRY_FLASH_TYPE_BEEP=4,
      BHENTRY_FLASH_TYPE_MBEEP=8
   };
   
private:
   Gtk::Connection   timer;
   int               state;
   int               counter;
   Gtk::string       text;
   GdkColor          fg;
   GdkColor          bg;
   BhEntryFlashType  type;
   GdkGC            *fg_gc;
   GdkGC            *bg_gc;
   
protected:
   //void focus_in_event_impl();
   //void focus_out_event_impl();
   void realize_impl();
   gint delete_event_impl(GdkEventAny*); 
   void enter_notify_event_impl();
   void leave_notify_event_impl();
   gint FlashStatus(gint);
   
public:
   BhEntry();
   BhEntry(guint max);
   void SetColour(GdkColor&, GdkColor&);
   void Flash(bool, BhEntryFlashType, int);
};

}

}

#endif   // _BHENTRY_H
